'From Squeak3.4 of 1 March 2003 [latest update: #5170] on 15 May 2003 at 7:06:16 pm'!
"Change Set:		selectedMessageWithoutSensor-chb
Date:			15 May 2003
Author:			Christopher H. Becker

Eliminate the 'feature' in CodeHolder>>selectedMessage and Browser>>selectedMessage that returns decompiled code when the Control or Shift key is held down. All code that references Sensor has been removed.

Prior to this change, using CTRL-S to save code in a browser with the duplicateControlAndAltKeys preference turned on caused decompiled code to be displayed.

(Tested in Squeak 3.4 #5170)"!


!CodeHolder methodsFor: 'construction' stamp: 'chb 5/15/2003 19:04'!
selectedMessage
	"Answer a copy of the source code for the selected message.  This generic version is probably actually never reached, since every subclass probably reimplements and does not send to super.  In time, ideally, most, or all, reimplementors would vanish and all would defer instead to a universal version right here.  Everything in good time."

	| class selector method |
	contents == nil ifFalse: [^ contents copy].
	self showingDecompile ifTrue:
		[^ self decompiledSourceIntoContents].

	class _ self selectedClassOrMetaClass.
	(class isNil or: [(selector _ self selectedMessageName) isNil]) ifTrue: [^ ''].
	method _ class compiledMethodAt: selector ifAbsent: [^ ''].	"method deleted while in another project"
	currentCompiledMethod _ method.

	((method fileIndex > 0) and: [(SourceFiles at: method fileIndex) == nil])
		ifTrue:
		["Emergency or no source file -- decompile without temp names"
		contents _ (class decompilerClass new decompile: selector in: class method: method)
			decompileString.
		contents _ contents asText makeSelectorBoldIn: class.
		^ contents copy].

	self showComment
		ifFalse:
			[contents _ self sourceStringPrettifiedAndDiffed]
		ifTrue:
			[contents _ self commentContents].
	^ contents _ contents copy asText makeSelectorBoldIn: class! !


!Browser methodsFor: 'message list' stamp: 'chb 5/15/2003 19:03'!
selectedMessage
	"Answer a copy of the source code for the selected message."

	| class selector method |
	contents == nil ifFalse: [^ contents copy].
	self showingDecompile ifTrue:
		[^ self decompiledSourceIntoContents].

	class _ self selectedClassOrMetaClass.
	selector _ self selectedMessageName.
	method _ class compiledMethodAt: selector ifAbsent: [^ ''].	"method deleted while in another project"
	currentCompiledMethod _ method.

	((method fileIndex > 0) and: [(SourceFiles at: method fileIndex) == nil])
		ifTrue:
		["Emergency or no source file -- decompile without temp names"
		contents _ (class decompilerClass new decompile: selector in: class method: method)
			decompileString.
		contents _ contents asText makeSelectorBoldIn: class.
		^ contents copy].

	self showingDocumentation
		ifFalse:
			[contents _ self sourceStringPrettifiedAndDiffed]
		ifTrue:
			[contents _ self commentContents].
	^ contents _ contents copy asText makeSelectorBoldIn: class! !

